<template>
  <v-container class="pa-0">
    <div class="mb-4 d-flex align-center">
      <span class="font-weight-bold">Importer liste animaux</span>
      <v-divider vertical class="ml-4 mr-2"></v-divider>
      <a href="/files/Modele_fichier_chien_militaire.xlsx" data-cy="AnimalDownloadFileBtn" download>
        <v-btn flat rounded>
          <v-icon left>file_download</v-icon>
          Télécharger modèle du fichier
        </v-btn>
      </a>
    </div>
    <v-row>
      <v-col cols="12" sm="4" class="mb-4 d-flex align-center">
        <v-file-input variant="outlined" density="compact" label="Importer liste animaux" data-cy="AnimalImportFileInput" v-model="file"
          @change="askParseFile" :disabled="loading || fileLoading || flight.archived" :accept="'.xlsx'"
          class="hide-details">
        </v-file-input>
        <v-progress-circular indeterminate class="ml-2" v-if="fileLoading" color="primary">
        </v-progress-circular>
      </v-col>
    </v-row>

    <FlightsCaseAnimalList :animalList="animalList" :flight="flight" @hasErrors="hasErrors = $event"
      @deleteAnimal="deleteAnimal($event)" @createEditAnimal="createEditAnimal($event)">
    </FlightsCaseAnimalList>
    <Teleport to="#teleports">
      <v-toolbar class="footer-action-toolbar" color="white">
        <v-spacer></v-spacer>
        <v-menu top offset-y v-if="showFinalize && !flight.archived">
          <template #activator="{ props }">
            <v-btn variant="outlined" rounded size="large" :loading="loading" v-bind="props" data-cy="AnimalImportChooseFinalizeBtn"
              class="mr-4 inverted text-uppercase">
              Finaliser
            </v-btn>
          </template>
          <v-list>
            <v-list-item v-for="(leg, index) in flight.legs" :key="index">
              <v-list-item-title>
                <div class="d-flex align-center">
                  <v-avatar size="30" class="mr-4 outlined">
                    {{ index + 1 }}
                  </v-avatar>
                  {{ leg.departure.oaci }} > {{ leg.arrival.oaci }}
                  <v-chip class="ml-4 text-uppercase status-chip" label :class="getStatusClass(leg.status)">
                    {{ legStatus[leg.status] }}
                  </v-chip>
                  <v-btn variant="outlined" rounded size="large" :loading="loading" @click="askFinalize(leg)"
                    :disabled="!canFinalize(leg) || flight.archived" data-cy="AnimalImportFinalizeBtn"
                    class="ml-4 inverted text-uppercase">
                    Finaliser
                  </v-btn>
                </div>
              </v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
        <v-btn variant="outlined" rounded size="large"
          :disabled="animalToSave.length > 0 || animalToDelete.length > 0 || animalList.length < 1" :loading="loading"
          data-cy="AnimalImportExportBtn" @click="exportAnimalList" class="mr-4 text-uppercase">
          Exporter liste animaux
        </v-btn>
        <v-btn variant="outlined" rounded size="large"
          :disabled="!isNewImportAnimalList && animalToSave.length < 1 && animalToDelete.length < 1 && animalList.findIndex(p => !p.id) < 0 || hasErrors || fileLoading || flight.archived"
          :loading="loading" @click="saveAnimalList" data-cy="AnimalImportSaveBtn" class="inverted text-uppercase">
          Enregistrer liste animaux
        </v-btn>
      </v-toolbar>
    </Teleport>
    <LazyFlightsCaseImportDialog v-if="importDialog" v-model="importDialog" @confirm="parseFile($event)"
      @close="importDialog = false" />

    <LazyFlightsCaseFinalizeDialog v-if="finalizeDialog" v-model="finalizeDialog" :legStatus="legSelected?.status"
      @confirm="finalize($event)" @close="finalizeDialog = false; legSelected = null;" />
  </v-container>
</template>

<script setup lang="ts">

import { saveAs } from 'file-saver';
import { editList, getStatusClass } from "../../../mixins/utilsMixin";
import { LegStatus } from "~/dto/legstatus.enum";
import { Flight } from "~/dto/flight.dto";
import { Animal } from "~/dto/animal.dto";
import { Leg } from "~/dto/leg.dto";

const { $api, $toast } = useNuxtApp();

const props = defineProps<{
  flight: Flight
}>();

const emit = defineEmits(['dataNotSaved'])

const legStatus = LegStatus;

// @ts-ignore
const animalList: Ref<Animal[]> = ref([...props.flight.animals]);
const animalToSave: Ref<number[]> = ref([]);
const animalToDelete: Ref<number[]> = ref([]);
const legSelected: Ref<Leg | null> = ref(null);
const file: Ref<any> = ref(null);
const importDialog = ref(false);
const fileLoading = ref(false);
const loading = ref(false);
const isNewImportAnimalList = ref(false);
const showFinalize = ref(false);
const finalizeDialog = ref(false)
const hasErrors = ref(false);

const askParseFile = () => {
  if (!file.value) {
    return;
  }
  if (animalList.value && animalList.value.length < 1) {
    return parseFile(false);
  }
  importDialog.value = true;
}

const parseFile = async (deleteAnimals: boolean) => {
  if (!file.value) {
    return;
  }
  const filesize = (file.value.size / 1024 / 1024);
  if (filesize > 5) {
    $toast.error('Le poids du fichier doit être inférieur à 5Mb.');
    return;
  }

  fileLoading.value = true;
  try {
    const newAnimals = await $api.animal.parse(props.flight.id, file.value);
    let lowerIndex = animalList.value.reduce((prev: number, current: Animal) => prev < current.id ? prev : current.id, 0);
    lowerIndex = lowerIndex > 0 ? 0 : lowerIndex;
    newAnimals.forEach((a: Animal) => {
      lowerIndex--;
      a.id = lowerIndex;
      animalToSave.value.push(a.id);
    });
    if (deleteAnimals) {
      animalList.value.forEach(a => animalToDelete.value.push(a.id));
    }
    animalList.value = deleteAnimals ? [...newAnimals] : animalList.value.concat(newAnimals);
    if (newAnimals.length < 1) {
      $toast.warning(`Le fichier a bien été lu mais aucune donnée n'est présente.`);
    }
    isNewImportAnimalList.value = true;
    emit('dataNotSaved', true);
  } catch (e) {
    $toast.error("Erreur lors de l'import de la liste d'animaux");
  }
  importDialog.value = false;
  fileLoading.value = false;
}

const saveAnimalList = async () => {
  try {
    loading.value = true;
    animalList.value = await $api.animal.updateList(getPayload(), props.flight.id);
    props.flight.animals = [...animalList.value];
    await Promise.all(props.flight.legs.map(async (l) => {
      l.status = await $api.leg.getStatus(l.id);
    }));
    isNewImportAnimalList.value = false;
    animalToSave.value = [];
    animalToDelete.value = [];
    emit('dataNotSaved', false);
    $toast.success('Liste d\'animaux est enregistrée');
  } catch (e) {
    $toast.error("Erreur lors de l'enregistrement de la liste d'animaux");
  }
  loading.value = false;
}

const exportAnimalList = async () => {
  try {
    loading.value = true;
    const res = await $api.animal.exportList(props.flight.id);
    const blob = new Blob([res], {
      type: 'application/vnd.ms-excel'
    });

    saveAs(blob, `LISTE_ANIMAUX.xlsx`);
  } catch (e) {
    $toast.error("Erreur lors de l'export de la liste d'animaux");
  }
  loading.value = false;
}

const createEditAnimal = (animal: Animal) => {
  if (!animal.id) {
    let lowerIndex = animalList.value.reduce((prev: number, current: Animal) => prev < current.id ? prev : current.id, 0);
    lowerIndex = lowerIndex > 0 ? 0 : lowerIndex;
    animal.id = lowerIndex - 1;
  }
  animalList.value = editList(animalList.value, animal);
  props.flight.animals = [...animalList.value];
  if (!!animal.id && animalToSave.value.findIndex(animalId => animalId === animal.id) < 0) {
    animalToSave.value.push(animal.id);
    emit('dataNotSaved', true);
  }
}

const deleteAnimal = (animal: Animal) => {
  animalList.value = animalList.value.filter(a => a.id !== animal.id);
  props.flight.animals = [...animalList.value];
  animalToDelete.value.push(animal.id);
  emit('dataNotSaved', true);
}

const checkAircraft = () => {
  const aircraft = JSON.parse(JSON.stringify(props.flight.aircraft));
  showFinalize.value = !(!!aircraft && aircraft.name !== 'Free Seating');
}

const getPayload = () => {
  let animals = animalList.value.filter(a => !a.id || animalToSave.value.includes(a.id));
  animals = animals.map(a => {
    // @ts-ignore
    a.id = a.id < 0 ? null : a.id;
    // @ts-ignore
    a.flight = { id: props.flight.id };
    return a;
  })
  return { animals, to_delete: animalToDelete.value.filter(id => id >= 0) };
}

const canFinalize = (leg: Leg): boolean => {
  return ['scheduled', 'lmc'].includes(leg.status);
}

const askFinalize = (leg: Leg) => {
  if (!canFinalize(leg) || !showFinalize.value) {
    return;
  }
  legSelected.value = leg;
  finalizeDialog.value = true;
}

const finalize = async ($event: any) => {
  loading.value = true;
  const leg = props.flight.legs.find(l => l.id === legSelected.value?.id);
  if (leg) {
    try {
      leg.documents = (await $api.leg.finalize(leg.id, $event)).documents;
      leg.status = await $api.leg.getStatus(leg.id);
      props.flight.documents = await $api.flightPaginated.getDocuments(props.flight.id);
      $toast.success("Génération des documents effectué");
    } catch (e) {
      $toast.error("Erreur lors de la génération des documents");
    }
    finalizeDialog.value = false;
    loading.value = false;
  }
}

watch(() => props.flight, () => {
  animalList.value = [...props.flight.animals];
  checkAircraft();
});

onMounted(() => {
  checkAircraft();
});

</script>
